; input: an expression including +, -, integer, (, )
; output: the value of input expression
	.MODEL small
	.386

	.STACK 100h

	.DATA
err0	DB	"Unexpected char $"
err1	DB	"Brackets Mismatch$"
err2	DB	"Internal Error$"
res	DB	5 DUP(0)

	.CODE
	.STARTUP
	push	"$"
	mov	ah, 1
	int	21h
getany:
	cmp	al, 0dh
	je	finish
	cmp	al, "("
	je	lparen
	cmp	al, ")"
	je	unexpected
	cmp	al, "-"
	je	negative
	mov	cx, 0		; cx = negative flag
	cmp	al, "+"
	jne	digits
	mov	ah, 1
	int	21h		; skip this +
	jmp	digits
negative:
	mov	cx, 1
	mov	ah, 1
	int	21h		; skip this -
digits:
	cmp	al, "0"
	jl	getanyread
	cmp	al, "9"
	jg	getanyread
	mov	bl, al		; init bx with first digit
	sub	bl, "0"
	xor	bh, bh
getch:
	mov	ah, 1
	int	21h
	cmp	al, "0"
	jl	numend
	cmp	al, "9"
	jg	numend
	sub	al, "0"
	imul	bx, 10
	xor	ah, ah
	add	bx, ax
	jmp	getch

lparen:
	xor	ah, ah
	push	ax		; push the paren
getanyread:
	mov	ah, 1
	int	21h
	jmp	getany

numend:
	cmp	cx, 0
	je	signed
	neg	bx		; bx is the current number
signed:
	pop	cx		; cx is the operation
	cmp	cx, "$"
	je	pushback
	cmp	cx, "("
	je	pushback
	cmp	cx, "+"
	je	addition
	cmp	cx, "-"
	je	substract
	jmp	error
addition:
	pop	cx
	add	cx, bx
	push	cx
	jmp	getop
substract:
	pop	cx
	sub	cx, bx
	push	cx
	jmp	getop
pushback:
	push	cx
	push	bx
	jmp	getop

getop:
	mov	bl, al		; bl is current character 
	cmp	bl, 0dh
	je	finish
	mov	ah, 1
	int	21h		; al is the next character
	cmp	bl, "+"
	je	plus
	cmp	bl, "-"
	je	minus
	cmp	bl, ")"
	je	rparen
	cmp	bl, "0"
	jl	getop
	cmp	bl, "9"
	jg	getop
	jmp	unexpected
plus:
minus:
	xor	bh, bh
	push	bx
	jmp	getany
rparen:
	pop	bx
	pop	cx
	cmp	cx, "("
	jne	mismatch
	jmp	signed		; bx is the result of this paren

finish:
	pop	ax		; ax is the result
	pop	bx
	cmp	bx, "$"
	jne	mismatch
	lea	si, res		; si is buffer pointer
	xor	cl, cl
	cmp	ax, 0
	jge	module
	neg	ax
	mov	cl, 1		; cl is result sign
module:
	xor	bx, bx		; bx is quotient
divide:				; 16-bit unsigned divide is broken in DOSBox
	sub	ax, 10
	cmp	ax, 0
	jl	dividedone
	add	bx, 1
	jmp	divide
dividedone:
	add	ax, 10
	mov	BYTE PTR [si], al	; remainder
	add	si, 1
	cmp	bx, 0
	je	printsign
	mov	ax, bx
	jmp	module
printsign:
	mov	ah, 2		; dos output
	cmp	cl, 0
	je	print
	mov	dl, "-"
	int	21h
print:
	sub	si, 1
	cmp	si, OFFSET res
	jl	return
	mov	dl, BYTE PTR [si]
	add	dl, "0"
	int	21h
	jmp	print

unexpected:
	mov	bl, al		; al is the unexpected char
	mov	ah, 09h
	lea	dx, err0
	int	21h
	mov	ah, 2
	mov	dl, bl
	int	21h
	jmp	return
mismatch:
	mov	ah, 09h
	lea	dx, err1
	int	21h
	jmp	return
error:
	mov	ah, 09h
	lea	dx, err2
	int	21h
	jmp	return
return:
	mov	ax, 4c00h	; return to dos
	int	21h
end
